/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{

	import starling.display.DisplayObject;
	import starling.text.TextField;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class Game extends Sprite
	{
		private var oSquare : Quad;
		
		private var oContent:Sprite; 
		
		private var r : Number = 0;
		private var g : Number = 0;
		private var b : Number = 0;
		private var rDest : Number;
		private var gDest : Number;
		private var bDest : Number;

		public function Game()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			simpleSquare(false);
			rotateSquare();
		}
		
		
		/**
		 * Création d'un carré simple.
		 * 
		 */
		private function simpleSquare(bAddChild:Boolean) : void
		{
			// définit la couleur de fond
			stage.color = 0xCCCCCC;

			// création d'un rectangle avec un dégradé de couleur
			oSquare = new Quad(200, 200);

			// pour créer un dégradé de couleur
			oSquare.setVertexColor(0, 0x006f77);
			oSquare.setVertexColor(1, 0xffffff);
			oSquare.setVertexColor(2, 0x00C5DF);
			oSquare.setVertexColor(3, 0x00FF00);

			// ou pour mettre une couleur unique
			// oSquare.color = 0x006f77;

			if( bAddChild)
			{
				oSquare.rotation = 60;
				oSquare.x = 250;
				oSquare.y = 300;
				addChild(oSquare);
			}	
		}
		
		/**
		 * Création d'un carré avec une rotation.
		 * 
		 */
		private function rotateSquare() : void
		{
			resetColors();
			oContent = new Sprite(); 
 
			var oLegend:TextField = new TextField(180, 20, "ActionScript Facile !", "Arial", 16, 0x00C5DF, true); 
			 
			oContent.addChild(oSquare); 
			oContent.addChild(oLegend); 
			
			// définit le point de référence, les coordonnées 0,0 
			oContent.pivotX = oContent.width >> 1; 
			oContent.pivotY = oContent.height >> 1; 
			 
			oContent.x = (stage.stageWidth - oContent.width >> 1 ) + (oContent.width >> 1); 
			oContent.y = (stage.stageHeight - oContent.height >> 1) + (oContent.height >> 1); 
			 
			addChild(oContent); 
			
			oContent.addEventListener(Event.ENTER_FRAME, onFrame);
		}


		private function onFrame(e : Event) : void
		{
			r -= (r - rDest) * .03; 
			g -= (g - gDest) * .03; 
			b -= (b - bDest) * .03; 
			 
			var color:uint = r << 16 | g << 8 | b; 
			oSquare.color = color; 
			 
			// when reaching the color, pick another one 
			if ( Math.abs( r - rDest) < 1 && Math.abs( g - gDest) < 1 && Math.abs( b - bDest) ) 
			  resetColors(); 
			 
			(e.currentTarget as DisplayObject).rotation += .02; 
		}

		private function resetColors() : void
		{
			rDest = Math.random() * 255;
			gDest = Math.random() * 255;
			bDest = Math.random() * 255;
		}
	}
}