/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{

	import com.demonsters.debugger.MonsterDebugger;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.display.DisplayObject;
	import starling.events.Touch;
	import starling.utils.deg2rad;

	import starling.textures.Texture;
	import starling.events.Event;
	import starling.display.Sprite;
	
	import flash.display.Bitmap;
	

	/**
	 * @author Administrateur
	 */
	public class GameImage extends Sprite
	{
		private const NUM_IMAGES:uint = 63; 
		
		private var logosVector:Vector.<CustomImage> = new Vector.<CustomImage>(NUM_IMAGES, true); 
		 
		[Embed(source = "../bin/logo-as3.jpg")] 
		private static const LogoAS3:Class; 


		public function GameImage()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAdded); 
		}
		
		
		private function onAdded(e : Event) : void
		{
			// create a Bitmap object out of the embedded image
			var logoBitmap : Bitmap = new LogoAS3();

			// create a Texture object to feed the Image object
			var texture : Texture = Texture.fromBitmap(logoBitmap);

			for (var i : int = 0; i < NUM_IMAGES; i++)
			{
				// création d'un objet image avec la texture
				var image : CustomImage = new CustomImage(texture);
				// set a random alpha, position, rotation

				image.alpha = Math.random();// transparence aléatoire
				
				// position aléatoire
				image.x = Math.random() * stage.stageWidth
				image.y = Math.random() * stage.stageHeight
				image.rotation = deg2rad(Math.random() * 360);
				
				addChild(image);// affichage
				
				logosVector[i] = image;// stockage de la référence pour une utilisation ultérieure
			}
			
			// écouteur sur chaque image
			stage.addEventListener(Event.ENTER_FRAME, onFrame); 
			
			// écouteur lorsque le sprite est cliqué
			stage.addEventListener(TouchEvent.TOUCH, onClick); 
		}

		private function onClick(e : TouchEvent) : void
		{
			// récupère les positions des cliques (des 2 doigts) par rapport à la scène
			var touches : Vector.<Touch> = e.getTouches(this);
			var clicked : DisplayObject = e.currentTarget as DisplayObject;

			// si un seul doigt est utilisé ou la souris
			if ( touches.length == 1 )
			{
				// récupération de la zone cliquée
				var touch : Touch = touches[0];

				// détection de la phase de clique
				if ( touch.phase ==TouchPhase.ENDED )
				{
					// sortie : [object Stage] [object CustomImage]
					MonsterDebugger.trace(this,"clique effectué");
					MonsterDebugger.trace(this,e.currentTarget);
					MonsterDebugger.trace(this,e.target);
				}
			}
		}
		
		
		private function onFrame(e : Event) : void
		{
			var lng : uint = logosVector.length;

			for (var i : int = 0; i < lng; i++)
			{
				// déplacement du logo
				var logo : CustomImage = logosVector[i];
				logo.x -= ( logo.x - logo.destX ) * .1;
				logo.y -= ( logo.y - logo.destY ) * .1;

				// lorsqu'il a atteint sa destination
				if ( Math.abs(logo.x - logo.destX) < 1 && Math.abs(logo.y - logo.destY) )
				{
					logo.destX = Math.random() * stage.stageWidth;
					logo.destY = Math.random() * stage.stageWidth;
					logo.rotation = deg2rad(Math.random() * 360);
				}
			} 
} 
	}
}
